##!/usr/bin/perl
#
# Schpati - Pre-Alpha of AndyChat v3.xx
# MODULE: Common
#
# Started on Wednesday, 9th of February, 2000 around 11pm-midnight
#
# Version 0.07 - 23rd of March, 2000
# -  (5.12pm) Hacked A_BOLD setting for colours to get it right, I hope.
# -  (5.17pm) Removed the code i just added, did nothing :)
# -  (5.55pm) Tried to fix RedrawLines updating stuffz
# -  (5.58pm) Applied fix to RedrawLines instead of RedrawNicks :P
# -  (7.43pm) Topics are now truncated to fit 1 space away from time
# - (11.42pm) ClearChatWindow destructive now works again
#
# Version 0.06 - 22nd of March, 2000
# -  (1.45am) RenUser hacked to only change name
# -  (1.11pm) ClWriteln no longer refresh(s) every line
# -  (2.52pm) Made ClWriteln check that lines 'exist' to avoid errors whilst debugging
# -  (4.40pm) DoubleQuote changed nicely :)
# -  (4.42pm) Added ^V inverse stuff for IRC
# -  (4.49pm) Rewrote Strrrp based on reallength
# -  (4.54pm) Implemented chsline (stripped chline), hell, uses a lot more ram, but
#             should make things a little faster.
#
# Version 0.05 - 21st of March, 2000
# -  (1.10pm) Fixed WrapLine (didn't do anything before becuase ac_wi undefined)
# -  (1.15pm) Fixed WrapLine more :)
# -  (1.25pm) Fixed WrapLine ?
# -  (1.30pm) Maybe the bug is in AddLine :)
# -  (3.19pm) Fixed alias character echo and later border removal bugs
# -  (3.26pm) Fixed voice sorting to be all together
# -  ( ---- ) Changed things
# -  (4.20pm) Delete now checks to make sure user exists before deleting and crashing
# -  (4.22pm) Removed stupid sort on delete code
# -  (8.10pm) Fixed ^_ weirdness
# -  (8.20pm) Started work on IRC colours
# -  (8.31pm) Phase 1 changes complete
# -  (8.32pm) Fixed typo in ClWriteln
# -  (8.35pm) Patched reallength for better detection of IRC colours
# -  (8.38pm) Attempting removable of deadly loop
# -  (8.50pm) Removable of several more IRC colour bugs
# -  (8.59pm) Hacked reallength to not bugger up things
# -  (9.08pm) Added irccol routine to convert ^C IRC colours -> textcolors
# -  (9.15pm) More spacing fixes with IRC colours
# -  (9.24pm) More fixes to do with IRC colours, see LordWrite, ClWriteln, reallength
# -  (9.42pm) Patched reallength with something I left out
# -  (9.47pm) Another fix for reallength :)
# - (10.21pm) Fixed reallength :)
#
# Version 0.04 - 20th of March, 2000
# - (11.01pm) Still trying to fix AddUser + SortUsers
# - ( ----- ) Gave up on AddUser + SortUsers again
# - ( ----- ) Added more window properties: control, channel
# - ( ----- ) Added new window property: nick
# -  (2.49am) Really fixed reallength incorrectly evaluating line length of ` lines :)
# -  ( ---- ) Patched ClWriteln to handle ^B (chr(2)) properly(?)
# -  ( ---- ) Patched ClWriteln to ignore characters below 29 as reallength does
#
# Version 0.03 - 5th of March, 2000
# - (11.01pm) Fixed reallength incorrectly evaluating line length of lines with ` in it
#
# Version 0.02 - 17th of February, 2000
# -  (1.56pm) Trying to fix lang problems
# -  (2.12pm) Uninitialised variable problems fixed, new sub newWindowInit (kinda dodgy)
# -  (2.15pm) Continued porting ReadConfig
# -  (4.51pm) Finished porting ReadConfig
# -  (4.51pm) Porting complete(?)
# -  (4.55pm) Fixed bug which I must have made during porting ReadConfig
# -  (4.59pm) Fixed another bug to do with DOS text files
# -  (5.05pm) Fixed ReadConfig logging warning about undefined nonsense
# -  ( ---- ) Argh!  Case-sensitive subs!  Renamed RealLength to reallength
# -  (5.22pm) Fixed(?) substr out of string bug
# -  (5.23pm) Fixed typo ac_text vs ac_texta in reallength
# -  (5.25pm) reallength now returns 0 instead of "" -- bug
# -  (9.06pm) ARGH!  Bloody variable reuse!!  Bloody Perl!!
# -  (9.15pm) Making progress on getting the text to go were it's supposed to (finally!)
# -  (9.22pm) Text now goes where it supposed to, erases last text correctly, and does not mess up the nick list!
# - (11.48pm) Fixed white bug
# - (12.16am) Did something silly :)  Implemented status colours for PROTOCOL_ICQ userlists (very unnecessary now)
# - (12.36am) Annihilated $ousers :)
# - (12.45am) Fixed AddUser
# - (12.51am) Rewrote DelUser
# -  (1.04am) Modified AddUser to one param again
# -  (1.23am) Added $whichwin parameter to AddUser, RenUser, NameOf and DelUser
# -  (1.44am) First implementation of SortUsers is done (for IRC, sort by mode)
# -  (1.45am) Began implementation of alphabetical (?) sorting in AddUser
#
# Version 0.02 - 13th of February, 2000
# - (12.47pm) Started porting Strrrp
# - (12.51pm) Finished porting Strrrp
# - (12.51pm) Started porting RealLength
# - (12.52pm) Finished porting RealLength
# - (12.53pm) Started porting WrapLine
# - (12.58pm) Finished porting WrapLine
# - (12.58pm) Started porting DoubleQuote
# -  (1.01pm) Finished porting DoubleQuote
# -  (1.03pm) Began finishing porting DrawMainScreen
# -  (1.06pm) Finished porting DrawMainScreen
# -  (1.06pm) Started porting AddLine
# -  (1.19pm) Finished porting AddLine
# -  (1.21pm) Started porting AddLog
# -  (1.22pm) Finished porting AddLog
# -  (1.23pm) Started porting AddUser
# -  ( ---- ) Fixed bug (from original AndyChat) to do with the online users count
# -  ( ---- ) Finished porting AddUser
# -  ( ---- ) Started porting RenUser
# -  (2.07pm) Finished porting RenUser
# -  (2.09pm) Implemented 'sortusers' into AddUser/RenUser for future expansion
# -  (2.10pm) Started porting FindUser
# -  (2.19pm) Finished porting FindUser
# -  (2.20pm) Started porting NameOf
# -  (2.22pm) Finished porting NameOf
# -  (2.23pm) Started porting DelUser
# -  ( ---- ) Fixed bug (from original AndyChat) to do with refreshing user view when unnecessary
# -  ( ---- ) Fixed bug (from original AndyChat) to do with the online users count
# -  (2.32pm) Finished porting DelUser
# -  (2.34pm) Started porting UpdateGame
# -  (2.47pm) Finished porting UpdateGame
# -  (2.49pm) Started porting strpNoSpace
# -  (2.51pm) Finished porting strpNoSpace
# -  (2.52pm) Started porting ReadConfig
# -  (3.05pm) Having break from porting ReadConfig
# -  (3.45pm) Began changing $usr structures - grrr, why can't Perl work how I want it to
# -  (4.09pm) Failed to fix bug which made AndyChat hang upon beeps in messies as well as ReadConfig
# -  (4.12pm) Fixed reused var (argh!  How many times will this happen!) which was the -real- cause of the last bug
#             even though the last bug probably did exist too :)
# -  ( ---- ) Fixed config reading
# -  ( ---- ) Fixed bugfix about the length of bits
#
# Version 0.01 - 12th of February, 2000
# -  (4.20pm) Implemented Lang instead of some hard coded stuffz
# -  (4.30pm) Began porting ClearChatWindow(destruct)
# -  (6.52pm) Ported all subs before ClearChatWindow and ClearChatWindow
# -  (6.53pm) Started porting ClearAliasWindow
# -  (6.54pm) Finished porting ClearAliasWindow
# -  (6.55pm) Started porting DrawLeft
# -  (7.07pm) Finished porting DrawLeft
#
# Version 0.00 - 9th of February, 2000
# - (11.xxpm) Initial Development
# - (12.00am) Moved DrawMainScreen into a_common.pl
# - (12.1xam) Wrote textcolor routine in curses2andy for easy(ier) colour changing
# - (12.38am) Started LordWrite
# - (xxxxxam) Finished LordWrite, LordWrite works (wow)
#
#use Curses;

#do 'andy-ext.pl';
#do 'curses2andy.pl';

$mainwin = initscr();
getmaxyx($mainwin, $maxy, $maxx);

start_color();

sub colline {
  my ($z1) = @_;

  $z2 = "1234567890!\@#\$\%";

  return substr($z2, $z1 - 1, 1);
}

sub irccol {
  my ($z1) = @_;

  $z1 = "0$z1";
  $z1 = " " . substr($z1, -2);
  $z2 = " 01 02 03 10 04 06 05 15 14 12 09 11 07 13 08 16";

  return index($z2, $z1) / 3;
}

sub LordWrite {
  my ($z1) = @_;
  $rl = 0;

  for ($z = 0; $z < length($z1); $z++)
  {
    if (substr($z1, $z, 1) eq chr(3))
    {
     if ($z + 1 < length($z1))
     {
      $z++;
      if ((index($colline, substr($z1, $z, 1)) > -1 && index($colline, substr($z1, $z, 1)) < 9) || substr($z1, $z, 1) eq "0")
      {
        if ($z + 1 < length($z1))
        {
          $z++;
          if ((index($colline, substr($z1, $z, 1)) > -1 && index($colline, substr($z1, $z, 1)) < 9) || substr($z1, $z, 1) eq "0")
          {
            $beforectrlc = getattrs($mainwin);
            textcolor(irccol(substr($z1, $z - 1, 2)));
          }
          else
          {
            $z--;
            $beforectrlc = getattrs($mainwin);
            textcolor(irccol(substr($z1, $z, 1)));
          }
        }
        else
        {
          $beforectrlc = getattrs($mainwin);
          textcolor(irccol(substr($z1, $z, 1)));
        }
      }
      else
      {
        if ($beforectrlc)
        {
          attrset($mainwin, $beforectrlc);
          $beforectrlc = "";
        }
        $z--;
      }
     }
     else
     {
        if ($beforectrlc)
        {
          attrset($mainwin, $beforectrlc);
          $beforectrlc = "";
        }
     }
    }
    elsif (substr($z1, $z, 1) eq "`")
    {
      if ($z + 1 < length($z1)) { $z++; }
      for (substr($z1, $z, 1))
      {
        if (/1/) { textcolor(1); }
        elsif (/2/) { textcolor(2); }
        elsif (/3/) { textcolor(3); }
        elsif (/4/) { textcolor(4); }
        elsif (/5/) { textcolor(5); }
        elsif (/6/) { textcolor(6); }
        elsif (/7/) { textcolor(7); }
        elsif (/8/) { textcolor(8); }
        elsif (/9/) { textcolor(9); }
        elsif (/0/) { textcolor(10); }
        elsif (/!/) { textcolor(11); }
        elsif (/\@/) { textcolor(12); }
        elsif (/#/) { textcolor(13); }
        elsif (/\$/) { textcolor(14); }
        elsif (/\%/) { textcolor(15); }
        elsif (/`/) { addstr(substr($z1, $z, 1)); $rl++; }
        else { addstr(substr($z1, $z - 1, 2)); $rl++; $rl++; }
      }
    }
    elsif (substr($z1, $z, 1) eq "")
    {
      if ($z + 1 < length($z1)) { $z++; }
      for (substr($z1, $z, 1))
      {
        if (//) { addstr(substr($z1, $z, 1)); $rl++; }
      }
    }
    else
    {
      addstr(substr($z1, $z, 1));
      $rl++;
    }
  }
}

sub RedrawNicks {
  if ($leftwindow ne 1) { return; }
  $tmpx = wherex; $tmpy = wherey; $tmpz = getattrs($mainwin);
  textcolor(15);
  $ac_i = 0; $ac_j = 0;

  while (($ac_i < $maxy - 5) && ($ac_j < $window[$thiswin]->{'users'}))
  {
    $ac_j++;
    if ((! $usr[$thiswin]->[$ac_j]->{invisible}) && ($usr[$thiswin]->[$ac_j]->{name} ne ""))
    {
      $ac_i++;
      gotoxy($maxx - 15, $ac_i + 1);
      if ($usr[$thiswin]->[$ac_j]->{op})
      {
        LordWrite("`\$\@"); textcolor(15);
      }
      elsif ($usr[$thiswin]->[$ac_j]->{voice})
      {
        LordWrite("`\9+"); textcolor(15);
      }
#      elsif ($window[$thiswin]->{protocol} eq PROTOCOL_ICQ)
#      {
#        $acrns = $usr[$thiswin]->[$ac_j]->{status};
#
#        if ($acrns eq ICQ_STATUS_INVISIBLE)
#        {
#          textcolor(8);
#        }
#        elsif ($acrns eq ICQ_STATUS_ONLINE)
#        {
#          textcolor(10);
#        }
#        elsif ($acrns eq ICQ_STATUS_AWAY)
#        {
#          textcolor(6);
#        }
#        elsif ($acrns eq ICQ_STATUS_NA)
#        {
#          textcolor(6);
#        }
#        elsif ($acrns eq ICQ_STATUS_OCCUPIED)
#        {
#          textcolor(5);
#        }
#        elsif ($acrns eq ICQ_STATUS_DND)
#        {
#          textcolor(5);
#        }
#        elsif ($acrns eq ICQ_STATUS_FREEFORCHAT)
#        {
#          textcolor(10);
#        }
#
#        if ($acrns eq ICQ_STATUS_ONLINE)
#        {
#          LordWrite("o`%");
#        }
#        elsif ($acrns eq ICQ_STATUS_AWAY)
#        {
#          LordWrite("a`%");
#        }
#        elsif ($acrns eq ICQ_STATUS_NA)
#        {
#          LordWrite("n`%");
#        }
#        elsif ($acrns eq ICQ_STATUS_OCCUPIED)
#        {
#          LordWrite("!`%");
#        }
#        elsif ($acrns eq ICQ_STATUS_DND)
#        {
#          LordWrite("d`%");
#        }
#        elsif ($acrns eq ICQ_STATUS_FREEFORCHAT)
#        {
#          LordWrite("f`%");
#        }
#      }
      else
      {
        addstr(" ");
      }
      LordWrite(strpadd($usr[$thiswin]->[$ac_j]->{name}, 12 + (length($usr[$thiswin][$ac_j]{name}) - reallength($usr[$thiswin][$ac_j]{name})), " ")); refresh;
    }
  }
  if ($lusers > $ac_i)
  {
    for ($ac_j = 1; $ac_j <= $lusers - $ac_i; $ac_j++)
    {
      addstr($ac_i + $ac_j + 1, $maxx - 15, SPACEs(14)); refresh;
    }
  }
  gotoxy($tmpx, $tmpy); attrset($mainwin, $tmpz);
  $lusers = $ac_i;
}

sub ClWriteln {
  my ($ac_towr) = @_;

  for ($aci = 0; $ac_towr && $aci < length($ac_towr); $aci++)
  {
#   if (1 eq 0)	# Hack!
#   {
    if (substr($ac_towr, $aci, 1) eq chr(7))
    {
      
    }
    elsif (substr($ac_towr, $aci, 1) eq chr(2))
    {
      if ($cbold)
      {
        attroff(A_BOLD);
        $cbold = "";
      }
      else
      {
        attron(A_BOLD);
        $cbold = 8;
      }
    }
    elsif (substr($ac_towr, $aci, 1) eq chr(21))
    {
      if ($culine)
      {
        attroff(A_UNDERLINE);
        $culine = "";
      }
      else
      {
        attron(A_UNDERLINE);
        $culine = 1;
      }
    }
    elsif (substr($ac_towr, $aci, 1) eq chr(22))
    {
      if ($cinverse)
      {
        attroff(A_REVERSE);
        $cinverse = "";
      }
      else
      {
        attron(A_REVERSE);
        $cinverse = 1;
      }
    }
    elsif (substr($ac_towr, $aci, 1) eq chr(3))
    {
     if ($aci + 1 < length($ac_towr))
     {
      $aci++;
      if ((index($colline, substr($ac_towr, $aci, 1)) > -1 && index($colline, substr($ac_towr, $aci, 1)) < 9) || substr($ac_towr, $aci, 1) eq "0")
      {
        if ($aci + 1 < length($ac_towr))
        {
          $aci++;
          if ((index($colline, substr($ac_towr, $aci, 1)) > -1 && index($colline, substr($ac_towr, $aci, 1)) < 9) || substr($ac_towr, $aci, 1) eq "0")
          {
            $beforectrlc = getattrs($mainwin);
            textcolor(irccol(substr($ac_towr, $aci - 1, 2)));
            attron(A_UNDERLINE) if ($culine);
            attron(A_REVERSE) if ($cinverse);
            attron(A_BOLD) if ($cbold);
          }
          else
          {
            $aci--;
            $beforectrlc = getattrs($mainwin);
            textcolor(irccol(substr($ac_towr, $aci, 1)));
            attron(A_UNDERLINE) if ($culine);
            attron(A_REVERSE) if ($cinverse);
            attron(A_BOLD) if ($cbold);
          }
        }
        else
        {
          $beforectrlc = getattrs($mainwin);
          textcolor(irccol(substr($ac_towr, $aci, 1)));
          attron(A_UNDERLINE) if ($culine);
          attron(A_REVERSE) if ($cinverse);
          attron(A_BOLD) if ($cbold);
        }
      }
      else
      {
        if ($beforectrlc)
        {
          attrset($mainwin, $beforectrlc);
          $beforectrlc = "";
          attron(A_UNDERLINE) if ($culine);
          attron(A_REVERSE) if ($cinverse);
          attron(A_BOLD) if ($cbold);
        }
        $aci--;
      }
     }
     else
     {
       if ($beforectrlc)
       {
         attrset($mainwin, $beforectrlc);
         $beforectrlc = "";
         attron(A_UNDERLINE) if ($culine);
         attron(A_REVERSE) if ($cinverse);
         attron(A_BOLD) if ($cbold);
       }
     }
    }
    elsif (substr($ac_towr, $aci, 1) eq "`")
    {
      $aci++;
      if ($aci > length($ac_towr))
      {
        addstr("`");
      }
      else
      {
        if (index($colline, substr($ac_towr, $aci, 1)) > -1)
        {
          textcolor(index($colline, substr($ac_towr, $aci, 1)) + 1);
          attron(A_UNDERLINE) if ($culine);
          attron(A_REVERSE) if ($cinverse);
          attron(A_BOLD) if ($cbold);
        }
        elsif (substr($ac_towr, $aci, 1) eq "`")
        {
          addstr("`");
        }
        else
        {
          addstr("`" . substr($ac_towr, $aci, 1));
        }
      }
    }
    elsif (ord(substr($ac_towr, $aci, 1)) > 31)
    {
      addstr(substr($ac_towr, $aci, 1));
    }
  }
  if ($cbold)
  {
    attroff(A_BOLD);
    $cbold = "";
  }
  if ($cinverse)
  {
    attroff(A_REVERSE);
    $cbold = "";
  }
  if ($culine)
  {
    attroff(A_UNDERLINE);
    $cbold = "";
  }
#  addstr($ac_towr);
#  addstr("\n");
#  refresh;
}

sub RedrawLines {
  if ($leftwindow ne 1) { return; }
  $tmpx = wherex; $tmpy = wherey; $tmpz = getattrs($mainwin);
  textcolor(7);
  for ($acrli = $maxy - 5; $acrli >= 1; $acrli--)
  {
    gotoxy(1, $maxy - 3 - $acrli);
    if (length($chsline[$thiswin]->[$acrli]) < length($chsline[$thiswin]->[$acrli + 1]))
    {
      ClWriteln($chline[$thiswin]->[$acrli] . strpadd("", length($chsline[$thiswin]->[$acrli + 1]) - length($chsline[$thiswin]->[$acrli]), " "));
    }
    else
    {
      ClWriteln($chline[$thiswin]->[$acrli]);
    }
  }
  while (index($chline[$thiswin]->[1], chr(7)) > -1)
  {
    $chline[$thiswin]->[1] = substr($chline[$thiswin]->[1], 0, index($chline[$thiswin]->[1], chr(7))) . substr($chline[$thiswin]->[1], index($chline[$thiswin]->[1], chr(7)) - 1);
  }
  gotoxy($tmpx, $tmpy); attrset($mainwin, $tmpz);
  refresh();
}

sub ReLabel {
  $rla = wherex; $rlb = wherey; $rlc = getattrs($mainwin);
  gotoxy($maxx - 15, $maxy - 2);
  addstr(strpadd("", 14 - length($progname), " "));
  LordWrite($progname);
  gotoxy($rla, $rlb); attrset($mainwin, $rlc);
}

sub ReTitle {
  my ($z1) = @_;

  $rla = wherex; $rlb = wherey; $rlc = getattrs($mainwin);
  gotoxy(1, 1); textcolor(8);
  if (length($z1) > $maxx - 23)
  {
    addstr(substr($z1, 0, $maxx - 23));
  }
  else
  {
    addstr($z1);
    textcolor($colour{'border'}); hline(Lang(6), $maxx - 23 - length($z1));
  }
  gotoxy($rla, $rlb); attrset($mainwin, $rlc);
}

sub DrawMainScreen {
  my ($mode) = @_;

  if (! $mode) { $mode = 0; }

  if (($mode eq 1) || ($mode eq 0))
  {
    textcolor($colour{'border'});
    addch(1, 0, Lang(5));
    hline(Lang(6), $maxx - 22);
    textcolor($colour{'time'});
#    addstr(1, $maxx - 21, "00:00");
    addstr(1, $maxx - 21, substr(qbTIME, 0, 5));
    textcolor($colour{'border'});
    addch(1, $maxx - 16, Lang(7));
    hline(Lang(6), 3);
    textcolor($colour{date});
#    addstr(1, $maxx - 12, "12/12/12");
    addstr(1, $maxx - 12, substr(qbDATE, 0, 2) . "/" . substr(qbDATE, 3, 2) . "/" . substr(qbDATE, -2, 2));
    textcolor($colour{border});
    gotoxy($maxx - 4, 1);
    hline(Lang(6), 3);
    addch(1, $maxx - 1, Lang(8));

    gotoxy(0, 2);
    vline(Lang(9), $maxy - 5);
    gotoxy($maxx - 16, 2);
    vline(Lang(9), $maxy - 5);
    gotoxy($maxx - 1, 2);
    vline(Lang(9), $maxy - 5);

#    gotoxy(0, $maxy - 3);
    addch($maxy - 3, 0, Lang(10));
    hline(Lang(6), $maxx - 17);
    addch($maxy - 3, $maxx - 16, Lang(11));
    hline(Lang(6), 14);
    addch($maxy - 3, $maxx - 1, Lang(12));

    gotoxy(0, $maxy - 2);
    vline(Lang(9), 1);
    gotoxy($maxx - 16, $maxy - 2);
    vline(Lang(9), 1);
    gotoxy($maxx - 1, $maxy - 2);
    vline(Lang(9), 1);

    addch($maxy - 1, 0, Lang(13));
    hline(Lang(6), $maxx - 17);
    addch($maxy - 1, $maxx - 16, Lang(14));
    hline(Lang(6), 14);
    addch($maxy - 1, $maxx - 1, Lang(15));

    textcolor(8);
    addstr($maxy - 1, $maxx - 15, "M:00");
    addstr($maxy - 1, $maxx - 5, "P:00");

#    gotoxy(3, $maxy - 2); LordWrite("`2A`0ndy`2C`0hat`9!");

    textcolor($colour{game});

    addstr(5, $maxx - 16, "0");
    addstr(9, $maxx - 16, "0");
    addstr(13, $maxx - 16, "0");
    addstr(17, $maxx - 16, "0");

    ReLabel;

    refresh();
  }
  if (($mode eq 2) || ($mode eq 0))
  {
    RedrawNicks;
  }
  if (($mode eq 3) || ($mode eq 0))
  {
    for ($ac_i = $maxy - 5; $ac_i > 0; $ac_i--)
    {
      gotoxy(1, $maxy - 3 - $ac_i);
      LordWrite(strpadd($chline[$thiswin]->[$ac_i], $maxx - 18, " "));
    }
  }
}

sub ClearChatWindow {
  my ($ac_destruct) = @_;

  $rla = wherex; $rlb = wherey; $rlc = getattrs($mainwin);

  for ($ac_i = 1; $ac_i <= $maxy - 5; $ac_i++)
  {
    gotoxy(1, $maxy - 3 - $ac_i);
    if ($leftwindow eq 1)
    {
      addstr(SPACEs(length($chsline[$thiswin]->[$ac_i])));
    }
    else
    {
      addstr(SPACEs($maxx - 18));
    }
    if ($ac_destruct)
    {
      $chline[$thiswin]->[$ac_i] = "";
      $chsline[$thiswin]->[$ac_i] = "";
    }
  }
  gotoxy($rla, $rlb); attrset($mainwin, $rlc);
  refresh;
}

sub ClearAliasWindow {
  for ($ac_i = 1; $ac_i <= $maxy - 5; $ac_i++)
  {
    addstr($maxy - 3 - $ac_i, $maxx - 14, SPACEs(12));
  }
  gotoxy(1, $maxy - 2);
}

sub DrawLeft {
  if ($leftwindow eq 2)
  {
    ClearChatWindow();
    ClearAliasWindow();
    Retitle("Pizza View Mode [ Type /LEFT to change ]");
    if ($pizza{'toppings'} > 0)
    {
      for ($ac_i = 1; $ac_i <= $pizza{'toppings'}; $ac_i++)
      {
        gotoxy(2, $ac_i + 1);
        textcolor(15);
        if ($ac_i < 10) { addstr(" "); }
        addstr($ac_i . "] " . $pizza_topping_name[$ac_i]);
        gotoxy($maxx - 14, $ac_i + 1);
        textcolor(14);
        addstr("\$ " . pricepadc($pizza_topping_price[$ac_i]));
      }
    }
    else
    {
      textcolor(12); addstr(2, 2, Lang(106));
    }
    $leftwindow = 2;
    textcolor(7); gotoxy(1, $maxy - 1);
  }
  elsif ($leftwindow eq 3)
  {
    ClearChatWindow();
    ClearAliasWindow();
    Retitle("Private Messages [ Type /LEFT to change ]");
    $leftwindow = 3;
    $addbuffer = "";
    @chlinb = @chline;
    for ($ac_i = 1; $ac_i <= $maxy - 4; $ac_i++)
    {
      AddLine("`!" . $pagess[$ac_i] . "`7");
    }
    $addbuffer = 1;
    $leftwindow = 1;
    redrawlines;
    @chline = @chlinb;
    $leftwindow = 3;
    textcolor(7); gotoxy(1, $maxy - 1);
  }
  else
  {
    $leftwindow = 2;
    ClearChatWindow();
    ClearAliasWindow();
    Retitle("[" . $window[$thiswin]->{channel} . "] " . $window[$thiswin]->{'topic'});
    $leftwindow = 1;
    RedrawLines;
    RedrawNicks;
    textcolor(7); gotoxy(1, $maxy - 1);
  }
}

sub Strrrp {
  my ($ac_text) = @_;

  $ac_outt = "";

  if ($ac_text)
  {
    for ($ac_ri = 0; $ac_ri < length($ac_text); $ac_ri++)
    {
      if (substr($ac_text, $ac_ri, 1) eq chr(3))
      {
       if ($ac_ri + 1 < length($ac_text))
       {
        $ac_ri++;
        if ((index($colline, substr($ac_text, $ac_ri, 1)) > -1 && index($colline, substr($ac_text, $ac_ri, 1)) < 9) || substr($ac_text, $ac_ri, 1) eq "0")
        {
          if ($ac_ri + 1 < length($ac_text))
          {
            $ac_ri++;
            if ((index($colline, substr($ac_text, $ac_ri, 1)) > -1 && index($colline, substr($ac_text, $ac_ri, 1)) < 9) || substr($ac_text, $ac_ri, 1) eq "0")
            {
            }
            else
            {
              $ac_ri--;
            }
          }
          else
          {
          }
        }
        else
        {
          $ac_ri--;
        }
       }
       else
       {
       }
      }
      elsif (substr($ac_text, $ac_ri, 1) eq "`")
      {
        if ($ac_ri + 1 < length($ac_text)) { $ac_ri++; }
        if (substr($ac_text, $ac_ri, 1) eq "`")
        {
          $ac_outt = $ac_outt . substr($ac_text, $ac_ri, 1);
        }
        elsif (index($colline, substr($ac_text, $ac_ri, 1)) < 0)
        {
          $ac_outt = $ac_outt . substr($ac_text, $ac_ri - 1, 2);
        }
      }
      elsif (ord(substr($ac_text, $ac_ri, 1)) > 31)
      {
        $ac_outt = $ac_outt . substr($ac_text, $ac_ri, 1);
      }
    }
  }
  return $ac_outt;
}

#sub Strrrp {
#  my ($ac_texta) = @_;
#
#  $ac_outt = "";
#  for ($ac_i = 0; $ac_i < length($ac_texta); $ac_i++)
#  {
#    if (substr($ac_texta, $ac_i, 1) eq "`")
#    {
#      if ($ac_i + 1 < length($ac_texta)) { $ac_i++; }
#      if (substr($ac_texta, $ac_i, 1) eq "`" || index($colline, substr($ac_texta, $ac_i, 1)) < 0) { $ac_outt = "$ac_outt" . substr($ac_texta, $ac_i, 1); }
#    }
#    elsif (substr($ac_texta, $ac_i, 1) eq "")
#    {  
#      if ($ac_i + 1 < length($ac_texta)) { $ac_i++; }
#      if (substr($ac_texta, $ac_i, 1) eq "") { $ac_outt = "$ac_outt"; }
#    }
#    elsif (ord(substr($ac_texta, $ac_i, 1)) > 31)
#    {
#      $ac_outt = $ac_outt . substr($ac_texta, $ac_i, 1);
#    }
#  }
#  return $ac_outt;
#}

sub reallength {
  my ($ac_text) = @_;

  $ac_rj = 0;

  if ($ac_text)
  {
    for ($ac_ri = 0; $ac_ri < length($ac_text); $ac_ri++)
    {
      if (substr($ac_text, $ac_ri, 1) eq chr(3))
      {
       if ($ac_ri + 1 < length($ac_text))
       {
        $ac_ri++;
        if ((index($colline, substr($ac_text, $ac_ri, 1)) > -1 && index($colline, substr($ac_text, $ac_ri, 1)) < 9) || substr($ac_text, $ac_ri, 1) eq "0")
        {
          if ($ac_ri + 1 < length($ac_text))
          {
            $ac_ri++;
            if ((index($colline, substr($ac_text, $ac_ri, 1)) > -1 && index($colline, substr($ac_text, $ac_ri, 1)) < 9) || substr($ac_text, $ac_ri, 1) eq "0")
            {
#              $ac_rj++;
#              $ac_rj++;
            }
            else
            {
#              $ac_rj++;
              $ac_ri--;
            }
          }
          else
          {
#            $ac_rj++;
          }
        }
        else
        {
#          $ac_rj++;
          $ac_ri--;
        }
       }
       else
       {
#         $ac_rj++;
       }
      }
      elsif (substr($ac_text, $ac_ri, 1) eq "`")
      {
        if ($ac_ri + 1 < length($ac_text)) { $ac_ri++; }
        if (substr($ac_text, $ac_ri, 1) eq "`")
        {
          $ac_rj++;
        }
        elsif (index($colline, substr($ac_text, $ac_ri, 1)) < 0)
        {
          $ac_rj++;
          $ac_rj++;
        }
      }
      elsif (substr($ac_text, $ac_ri, 1) eq "")
      {  
        if ($ac_ri + 1 < length($ac_text)) { $ac_ri++; }
        if (substr($ac_text, $ac_ri, 1) eq "")
        {
          $ac_rj++;
        }
        elsif (index($colline, substr($ac_text, $ac_ri, 1)) < 0)
        {
          $ac_rj++;
          $ac_rj++;
        }
      }
      elsif (ord(substr($ac_text, $ac_ri, 1)) > 31)
      {
        $ac_rj++;
      }
    }
  }
  return $ac_rj;
}

sub WrapLine {
  my ($ac_line1) = @_;

  $leftover = "";
  $ac_wi = length($ac_line1);
  while (($ac_wi > 0) && (substr($ac_line1, $ac_wi - 1, 1) ne " "))
  {
    $leftover = substr($ac_line1, $ac_wi - 1);
    $ac_wi = $ac_wi - 1;
  }
  if ($leftover eq $ac_line1) { $leftover = ""; }
  return substr($ac_line1, 0, length($ac_line1) - length($leftover) - 1);
}

sub DoubleQuote {
  my ($ac_line) = @_;

  $ac_line =~ s/`/``/go;
#  $tempstr = ""; $ac_di = 0;
#  for ($ac_di = 0; $ac_di < length($ac_line); $ac_di++)
#  {
#    if (substr($ac_line, $ac_di, 1) eq "`")
#    {
#      $tempstr = "$tempstr`";
#    }
#    elsif (substr($ac_line, $ac_di, 1) eq "")
#    {
#      $tempstr = "$tempstr";
#    }
#    $tempstr = $tempstr . substr($ac_line, $ac_di, 1);
#  }
  return $ac_line;
}

sub AddLine {
  my ($ac_line, $ac_saidwrap, $ac_remsend) = @_;

  $leftover = "";
  $ac_k = 0;
  if ($ac_saidwrap)
  {
    $ac_line = DoubleQuote($ac_line);
  }
  rescroll:
  $ac_i = 0; $ac_j = 0;
  if (reallength($ac_line) < $maxx - 18 - reallength($ac_saidwrap))
  {
    $displine = $ac_line;
    $ac_line = "";
    $ac_j = 1;
    $ac_k++;
  }
  else
  {
    $tmpline[1] = ""; $tmpline[2] = "";
    if (index($ac_line, " ") < 0)
    {
      $tmpline[1] = substr($ac_line, 0, $maxx - 19 - reallength($ac_saidwrap));
      $ac_line = substr($ac_line, $maxx - 17 - reallength($ac_saidwrap), length($ac_line) - ($maxx - 19 - reallength($ac_saidwrap)));
    }
    else
    {
      $tmpline[1] = ""; $ac_l = 0;
      $tmpline[1] = WrapLine(substr($ac_line, 0, $maxx - 19 - reallength($ac_saidwrap)));
      $ac_line = $leftover . substr($ac_line, $maxx - 19 - reallength($ac_saidwrap), length($ac_line) - ($maxx - 19 - reallength($ac_saidwrap)));
    }
    $displine = $tmpline[1];
    $ac_j = 1;
    $ac_k++;
  }
  if ($ac_saidwrap)
  {
    if ($ac_k eq 1)
    {
      $displine = $ac_saidwrap . $displine;
    }
    else
    {
      $displine = SPACEs(reallength($ac_saidwrap)) . $displine;
    }
  }
  if ($ac_j > 0)
  {
    for ($ac_i = $maxy - 4; $ac_i > 1; $ac_i--)
    {
      $chline[$thiswin]->[$ac_i] = $chline[$thiswin]->[$ac_i - 1];
      $chsline[$thiswin]->[$ac_i] = $chsline[$thiswin]->[$ac_i - 1];
    }
    $chline[$thiswin][1] = $displine;
    $chsline[$thiswin][1] = Strrrp($displine);

    if ($remsend)
    {
      # SendIPX("@@" . $me{'room'} . $displine, $ipxsocket);
    }
    if (($logging) && ($addbuffer))
    {
      print logfile $chsline[$thiswin]->[1] . "\n";
    }
  }
  RedrawLines;
  if ($ac_line ne "")
  {
    goto rescroll;
  }
}

sub AddLog {
  my ($ac_logline) = @_;

  if ($logging)
  {
    print logfile "$ac_logline\n";
  }
}

sub SortUsers {
  my ($whichwin) = @_;

  $acsuj = $window[$whichwin]->{users} + 1;
  $acsui = $window[$whichwin]->{users};
  $acsuk = 1;

  if ($acsui > 1)
  {
      # if ($window[$whichwin]->{protocol} eq PROTOCOL_IRC)
      # {
#        AddLine("", "I am sorting now said $usr[$whichwin][$acsui]{'name'}");
        for ($acsuk = 1; $acsuk < $window[$whichwin]->{users}; $acsuk++)
        {
          if (($usr[$whichwin]->[$acsuk]{op} && $usr[$whichwin]->[$acsui]{op}) ||
              ($usr[$whichwin][$acsuk]{voice} && $usr[$whichwin][$acsui]{voice}))
          {
          }
          elsif ((! $usr[$whichwin][$acsuk]{op} && ! $usr[$whichwin][$acsui]{op}) &&
                 (! $usr[$whichwin][$acsuk]{voice} && ! $usr[$whichwin][$acsui]{voice}))
          {
          }
          else
          {
            $usr[$whichwin]->[$acsuj] = $usr[$whichwin]->[$acsui];
            $usr[$whichwin]->[$acsui] = $usr[$whichwin]->[$acsuk];
            $usr[$whichwin]->[$acsuk] = $usr[$whichwin]->[$acsuj];
            $usr[$whichwin]->[$acsuj] = ();
            
            last;
          }
        }
#        elsif ($usr[$whichwin]->[$acsui + 1]->{op})
#        {
#          $usr[$whichwin]->[$acsuj] = $usr[$whichwin]->[$acsui];
#          $usr[$whichwin]->[$acsui] = $usr[$whichwin]->[$acsui + 1];
#          $usr[$whichwin]->[$acsui + 1] = $usr[$whichwin]->[$acsuj];
#          $usr[$whichwin]->[$acsuj] = ();
##          AddLine("", "Moved Op: $usr[$whichwin][$acsui]{'name'}");
##          AddLine("", "New Op: $usr[$whichwin][$acsui+1]{'name'}");
#        }
#        elsif ($usr[$whichwin]->[$acsui]->{voice})
#        {
#          AddLine("", "Evil Voice");
#        }
#        elsif ($usr[$whichwin]->[$acsui + 1]->{voice})
#        {
#          AddLine("", "Voice");
#          $usr[$whichwin]->[$acsuj] = $usr[$whichwin]->[$acsui];
#          $usr[$whichwin]->[$acsui] = $usr[$whichwin]->[$acsui + 1];
#          $usr[$whichwin]->[$acsui + 1] = $usr[$whichwin]->[$acsuj];
#          $usr[$whichwin]->[$acsuj] = ();
#        }
      # }
  }
#  AddLine("", "--");
}

sub AddUser {
  my ($whichwin, $newusr) = @_;

#  if ($usr[$whichwin]->[$whichnum]->{exists}) { AddLine("User clash!", Lang(16)); }
  $window[$whichwin]->{users}++;
  $usr[$whichwin]->[$window[$whichwin]->{users}]->{name} = $newusr;
#  $usr[$whichwin]->[$window[$whichwin]->{users}]->{exists} = 1;
  if ($window[$whichwin]->{sortusers})
  {
    SortUsers($whichwin);
  }
#  $acaul = $window[$whichwin]->{users} + 1;
#  if ($acaul > 2)
#  {
#    for ($acaui = 1; $acaui <= $window[$whichwin]->{users}; $acaui++)
#    {
#      $acauj[0] = $usr[$whichwin]->[$acaui]->{name};
#      $acauj[1] = $usr[$whichwin]->[$acsuk]->{name};
#      @acauk = sort @acauj;
#      if (($acauj[0] ne $acauk[0]) && (! ($usr[$whichwin][$acaui]{op} && $usr[$whichwin][$acsuk]{op}) || ! (! $usr[$whichwin][$acaui]{op} && ! $usr[$whichwin][$acsuk]{op})))
#      {
#        $usr[$whichwin]->[$acaul] = $usr[$whichwin]->[$acaui];
#        $usr[$whichwin]->[$acaui] = $usr[$whichwin]->[$acsuk];
#        $usr[$whichwin]->[$acsuk] = $usr[$whichwin]->[$acaul];
#        $usr[$whichwin]->[$acaul] = ();
#        last;
#      }
#    }
#  }
  if ($window[$whichwin]->{sortusers})
  {
    if ($thiswin eq $whichwin) { RedrawNicks; }
  }
  else
  {
    if ($window[$whichwin]->{users} <= $maxy - 5) { if ($thiswin eq $whichwin) { RedrawNicks; } }
  }
}

sub RenUser {
  my ($whichwin, $oldusr, $renusr) = @_;

#  $ac_changedulist = "";
  $ac_j = 0;
  for ($ac_i = 1; $ac_i <= $window[$whichwin]->{users}; $ac_i++)
  {
    if (! $usr[$whichwin]->[$ac_i]->{invisible}) { $ac_j++; }
    if ($usr[$whichwin]->[$ac_i]->{name} eq $oldusr)
    {
      $usr[$whichwin]->[$ac_i]->{name} = $renusr;
      last;
    }
  }
#  $acaul = $window[$whichwin]->{users} + 1;
#  for ($acaui = 1; $acaui < $window[$whichwin]->{users}; $acaui++)
#  {
#    $acauj[0] = $usr[$whichwin]->[$acaui]->{name};
#    $acauj[1] = $usr[$whichwin]->[$acaui+1]->{name};
#    @acauk = sort @acauj;
#    if ($acauj[0] ne $acauk[0])
#    {
#      $usr[$whichwin]->[$acaul] = $usr[$whichwin]->[$acaui];
#      $usr[$whichwin]->[$acaui] = $usr[$whichwin]->[$acaui+1];
#      $usr[$whichwin]->[$acaui+1] = $usr[$whichwin]->[$acaul];
#      $usr[$whichwin]->[$acaul] = ();
#    }
#  }
  if ($window[$whichwin]->{sortusers})
  {
#    SortUsers($whichwin);
    if ($thiswin eq $whichwin) { RedrawNicks; }
  }
  else
  {
    if ($ac_j <= $maxy - 5) { if ($thiswin eq $whichwin) { RedrawNicks; } }
  }
}

sub FindUser {
  my ($whichwin, $forwhat, $findusr) = @_;

  for ($ac_i = 1; $ac_i <= $window[$whichwin]->{users}; $ac_i++)
  {
    if ((uc($usr[$whichwin]->[$ac_i]->{name}) eq uc($findusr)) && (($forwhat eq 1) || ($forwhat eq 0)))
    {
      return $ac_i;
    }
#    elsif ((substr(uc($usr[$whichwin]->[$ac_i]->{name}), 2, length($usr[$whichwin]->{name}) - 2) eq uc($findusr)) && (($forwhat eq 1) || ($forwhat eq 0)))
#    {
#      return $ac_i;
#    }
    elsif ((uc($usr[$whichwin]->[$ac_i]->{id}) eq uc($findusr)) && (($forwhat eq 2) || ($forwhat eq 0)))
    {
      return $ac_i;
    }
  }
  return "";
}

sub NameOf {
  my ($whichwin, $ac_userid) = @_;

  for ($ac_i = 1; $ac_i <= $window[$whichwin]->{users}; $ac_i++)
  {
    if (uc($usr[$whichwin]->[$ac_i]->{id}) eq uc($ac_userid))
    {
      return $usr[$whichwin]->[$ac_i]->{name};
    }
  }
  return "Mr Mysterious";
}

sub DelUser {
  my ($whichwin, $delusr) = @_;

  $changedulist = "";
  $ac_j = 0; $ac_k = 0;

  $delusr = FindUser($whichwin, 1, $delusr);

  if ($delusr)
  {
    if ($delusr < $window[$whichwin]->{users})
    {
      for ($acdui = $delusr; $acdui < $window[$whichwin]->{users}; $acdui++)
      {
        @usr[$whichwin]->[$acdui] = @usr[$whichwin]->[$acdui + 1];
      }
    }

    $usr[$whichwin]->[$window[$whichwin]->{users}] = ();

    $window[$whichwin]->{users}--;
  }

#  $acaul = $window[$whichwin]->{users} + 1;
#  for ($acaui = 1; $acaui < $window[$whichwin]->{users}; $acaui++)
#  {
#    $acauj[0] = $usr[$whichwin]->[$acaui]->{name};
#    $acauj[1] = $usr[$whichwin]->[$acaui+1]->{name};
#    @acauk = sort @acauj;
#    if ($acauj[0] ne $acauk[0])
#    {
#      $usr[$whichwin]->[$acaul] = $usr[$whichwin]->[$acaui];
#      $usr[$whichwin]->[$acaui] = $usr[$whichwin]->[$acaui+1];
#      $usr[$whichwin]->[$acaui+1] = $usr[$whichwin]->[$acaul];
#      $usr[$whichwin]->[$acaul] = ();
#    }
#  }

  if ($window[$whichwin]->{sortusers})
  {
#    SortUsers($whichwin);
    if ($whichwin eq $thiswin) { RedrawNicks; }
  }
  else
  {
    if ($window[$whichwin]->{users} <= $maxy - 5) { if ($whichwin eq $thiswin) { RedrawNicks; } }
  }

# The old new way (doesn't work anyhow) ...
#
#  for ($ac_i = 1; $ac_i <= $window[$thiswin]->{users}; $ac_i++)
#  {
#    if ($usr[$thiswin]->[$ac_i]->{invisible} ne "") { $ac_k++; }
#    if (($usr[$thiswin]->[$ac_i]->{name} eq $delusr{name}) || ($usr[$thiswin]->[$ac_i]->{id} eq $delusr{id}))
#    {
##      @usr[$thiswin]->[$ac_i] = ();
#      if ($ac_k < $maxy - 5) { RedrawNicks; }
#    }
#  }

}

sub UpdateGame {
  my ($wgame) = @_;

  $uga = wherex; $ugb = wherey; $ugc = getattrs($mainwin);
  textcolor(8);
  if (($wgame >= 1) && ($wgame <= 4))
  {
    addstr($wgame * 4 + 1, $maxx - 17, $game[$thiswin]->[$wgame]->{maxplay} - $game[$thiswin]->[$wgame]->{players});
  }
  elsif ($wgame eq 5)
  {
    gotoxy($maxx - 13, $maxy - 1);
    if ($messwaiting > 18) { textcolor(28); }
    elsif ($messwaiting > 14) { textcolor(12); }
    elsif ($messwaiting > 9) { textcolor(4); }
    else { addstr("0"); }
    addstr($messwaiting); refresh;
  }
  elsif ($wgame eq 6)
  {
    gotoxy($maxx - 3, $maxy - 1);
    if ($pagesswaiting < 2) { textcolor(28); }
    elsif ($pagesswaiting < 6) { textcolor(12); }
    elsif ($pagesswaiting < 11) { textcolor(4); }
    if (22 - $paggesswaiting < 10) { addstr("0"); }
    addstr(22 - $pagesswaiting);
  }
  gotoxy($uga, $ugb); attrset($mainwin, $ugc);
}

sub strpNoSpace {
  my ($ac_texty) = @_;

  $ac_texty = Strrrp($ac_texty);

  while (index($ac_texty, " ") > -1)
  {
    $ac_texty = substr($ac_texty, 0, index($ac_texty, " ") - 1) . substr($ac_texty, index($ac_texty, " ") - 1);
  }

  return $ac_texty;
}

sub newWindowInit {
  my ($acz, $acy) = @_;

  $window[$acz]->{users} = 0;
  $window[$acz]->{protocol} = $acy;
  $window[$acz]->{topic} = "";
  $window[$acz]->{control} = "";
  $window[$acz]->{channel} = "";
#  $window[$acz]->{nick} = $my{'nick'};			# Broken Hack!
#  $my[$acz]->{nick} = $me{'nick'};			# Worse Hack!
  $my[$acz]->{name} = $me{'name'};			# Better Hack!

  for ($aci = 1; $aci <= $maxy - 5; $aci++)
  {
    $chline[$acz]->[$aci] = "";
    $chsline[$acz]->[$aci] = "";
  }

  for ($aci = 1; $aci <= 4; $aci++)
  {
    $game[$acz]->[$aci]->{maxplay} = 0;
    $game[$acz]->[$aci]->{players} = 0;
  }

  $pizza[$acz]{host} = "";
  $pizza[$acz]{toppings} = 0;

}

sub ReadConfig {
  $me{'name'} = "";
  $defalias = "";
  $andypath = "./";
  $dukepath = "";
  $doom2path = "";
  $bloodpath = "";
  $swpath = "";
  $rottpath = "";
  $doompath = "";
  $wormspath = "";
  $quakepath = "";
  # $mp3path = "";
  $mp3app = "";
  $paging = 1;
  $cdstoponexit = "";
  $me{'invisible'} = "";
  $nolang = 1;
  $langua = "";
  $logging = "";
  $me{'room'} = "001";
#  $thisroom{'topic'} = 
  $thiswin = 1;
  $window[$thiswin]->{topic} = "Lobby";
  $window[$thiswin]->{op} = 0;
  $window[$thiswin]->{protocol} = ANDYCHAT;
  $window[$thiswin]->{sortusers} = "";
  $cf = "";

  $colour{'border'} = 1; $colour{'topline'} = 2;
  $colour{'scrolly'} = 1; $colour{'pagemsg'} = 11;
  $colour{'typemsg'} = 14; $colour{'scrollback'} = 14;
  $colour{'time'} = 8; $colour{'date'} = 8; $colour{'game'} = 8;

  if ((-f "andychat.ini") && (-r "andychat.ini"))
  {
    open(F, "andychat.ini");
    @flines = <F>;
    close(F);
    $fsize = @flines;

    for ($i = 0; $i < $fsize; $i++)
    {
      $str1 = ltrim(rtrim(substr($flines[$i], 0, -1)));
      if ((substr($str1, -1, 1) eq chr(13)) || (substr($str1, -1, 1) eq chr(10)))
      {
        $str1 = substr($str1, 0, -1);
      }
      if (substr($str1, 0, 1) eq ";")
      {
      }
      elsif (substr(lc($str1), 0, 9) eq "defalias=")
      {
        if (length($str1) > 9) { $defalias = strpNoSpace(substr($str1, 9)); }
        if (length($defalias) > 12) { $defalias = substr($defalias, 0, 12); }
        $me{'name'} = $defalias;
      }
      elsif (substr(lc($str1), 0, 9) eq "andypath=")
      {
        if (length($str1) > 9) { $andypath = substr($str1, 9); }
        if (substr($andypath, -1, 1) ne "/") { $andypath = "$andypath/"; }
      }
      elsif (substr(lc($str1), 0, 9) eq "dukepath=")
      {
        if (length($str1) > 9) { $dukepath = substr($str1, 9); }
      }
      elsif (substr(lc($str1), 0, 9) eq "doompath=")
      {
        if (length($str1) > 9) { $doompath = substr($str1, 9); }
      }
      elsif (substr(lc($str1), 0, 10) eq "doom2path=")
      {
        if (length($str1) > 10) { $doom2path = substr($str1, 10); }
      }
      elsif (substr(lc($str1), 0, 10) eq "bloodpath=")
      {
        if (length($str1) > 10) { $bloodpath = substr($str1, 10); }
      }
      elsif (substr(lc($str1), 0, 10) eq "wormspath=")
      {
        if (length($str1) > 10) { $wormspath = substr($str1, 10); }
      }
      elsif (substr(lc($str1), 0, 10) eq "quakepath=")
      {
        if (length($str1) > 10) { $quakepath = substr($str1, 10); }
      }
      elsif (substr(lc($str1), 0, 7) eq "swpath=")
      {
        if (length($str1) > 7) { $swpath = substr($str1, 7); }
      }
      elsif (substr(lc($str1), 0, 9) eq "rottpath=")
      {
        if (length($str1) > 9) { $rottpath = substr($str1, 9); }
      }
      elsif (substr(lc($str1), 0, 10) eq "invisible=")
      {
	$str1 = ltrim(substr($str1, 10));
        $str2 = substr($str1, 1, 1); $str1 = substr($str1, 0, 1);
        if (($str1 eq "1") || (lc($str1) eq "t") || (lc($str1) eq "y") || (lc($str2) eq "n"))
        {
          # To be re-implemented later .. perhaps
        }
      }
      elsif (substr(lc($str1), 0, 7) eq "paging=")
      {
	$str1 = ltrim(substr($str1, 7));
        $str2 = substr($str1, 1, 1); $str1 = substr($str1, 0, 1);
        if (($str1 eq "0") || (lc($str1) eq "f") || (lc($str1) eq "n") || (lc($str2) eq "f"))
        {
          $paging = 0;
        }
      }
      elsif (substr(lc($str1), 0, 13) eq "cdstoponexit=")
      {
	$str1 = ltrim(substr($str1, 13));
        $str2 = substr($str1, 1, 1); $str1 = substr($str1, 0, 1);
        if (($str1 eq "1") || (lc($str1) eq "t") || (lc($str1) eq "y") || (lc($str2) eq "n"))
        {
          $cdstoponexit = 1;
        }
      }
      elsif (substr(lc($str1), 0, 5) eq "room=")
      {
        # To be re-implemented later .. perhaps
      }
      elsif (substr(lc($str1), 0, 9) eq "language=")
      {
        if (length($str1) > 9)
        {
          $langua = substr($str1, 9);
          if (-r $langua)
          {
            $nolang = "";
            open(langfile, $langua);
            @langline = <langfile>;
            close(langfile);
            $langsize=@langline;
            for ($j = 0; $j < $langsize; $j++)
            {
              $langline[$j] = substr($langline[$j], 0, -1);
              if ((substr($langline[$j], -1, 1) eq chr(13)) || (substr($langline[$j], -1, 1) eq chr(10)))
              {
                $langline[$j] = substr($langline[$j], 0, -1);
              }
            }
          }
        }
      }
      elsif (substr(lc($str1), 0, 8) eq "colours=")
      {
        if (length($str1) > 8)
        {
          $langua = substr($str1, 8);
          if (-r $langua)
          {
            open(CFILE, $langua);
            @CLINES=<CFILE>;
            close(CFILE);
            $CSIZE=@CLINES;

            for ($j = 0; $j < $CSIZE; $j++)
            {
              $langua = lc(substr($CLINES[$j], 0, -1));
              if ((substr($langua, 0, 7) eq "border=") || (substr($langua, 0, 8) eq "topline=") ||
                  (substr($langua, 0, 8) eq "scrolly=") || (substr($langua, 0, 8) eq "pagemsg=") ||
                  (substr($langua, 0, 8) eq "typemsg=") || (substr($langua, 0, 11) eq "scrollback=") ||
                  (substr($langua, 0, 5) eq "date=") || (substr($langua, 0, 5) eq "time=") ||
                  (substr($langua, 0, 5) eq "game=") || (substr($langua, 0, 6) eq "topic="))
              {
                $bla = substr($langua, 0, index($langua, "="));
                $colour{$bla} = int(ltrim(rtrim(substr($langua, -2, 2))));
              }
            }
            $cf = 1;
          }
        }
      }
      elsif (substr(lc($str1), 0, 8) eq "logging=")
      {
        if (length($str1) eq 9)
        {
          $str1 = substr($str1, 8);
          if (($str1 eq "1") || (lc($str1) eq "t") || (lc($str1) eq "y"))
          {
            $logging = 1;
            open(logfile, ">>$andypath" . "andychat.log");
            print logfile "\nLogfile opened on " . qbDATE() . " @ " . qbTIME() . "\n\n";
          }        
        }
        else
        {
          $str1 = substr($str1, 8);
          if ((lc($str1) eq "yes") || (lc($str1) eq "true") || (lc($str1) eq "on"))
          {
            $logging = 1;
            open(logfile, ">>$andypath$+andychat.log");
            print logfile "\nLogfile opened on " . qbDATE() . " @ " . qbTIME() . "\n\n";
          }
          else
          {
            $logging = 1;
            open(logfile, ">>$andypath$str1");
            print logfile "\nLogfile opened on " . qbDATE() . " @ " . qbTIME() . "\n\n";
          }
        }
      }
    }
  }
  if ((not $cf) && (-r "colour.ini"))
  {
    open(CFILE, "colour.ini");
    @CLINES=<CFILE>;
    close(CFILE);
    $CSIZE=@CLINES;

    for ($j = 0; $j < $CSIZE; $j++)
    {
      $langua = lc(substr($CLINES[$j], 0, -1));
      if ((substr($langua, 0, 7) eq "border=") || (substr($langua, 0, 8) eq "topline=") ||
          (substr($langua, 0, 8) eq "scrolly=") || (substr($langua, 0, 8) eq "pagemsg=") ||
          (substr($langua, 0, 8) eq "typemsg=") || (substr($langua, 0, 11) eq "scrollback=") ||
          (substr($langua, 0, 5) eq "date=") || (substr($langua, 0, 5) eq "time=") ||
          (substr($langua, 0, 5) eq "game=") || (substr($langua, 0, 6) eq "topic="))
      {
        $bla = substr($langua, 0, index($langua, "="));
        $colour{$bla} = int(ltrim(rtrim(substr($langua, -2, 2))));
      }
    }
    $cf = 1;
  }
}

$colline = "1234567890!\@#\$\%";
